<?php

namespace Modules\User\Requests\Web;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\User\Enums\UserRoleEnum;
use Modules\User\Services\UserService;

class VerifyRequest extends FormRequest
{
    public function __construct(
        private UserService $userService
    ){}

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules =
        [
            'email'=>
            [
                'required',
                'email'
            ],
            'code_1'=>
            [
                'required'
            ],
            'code_2'=>
            [
                'required'
            ],
            'code_3'=>
            [
                'required'
            ],
            'code_4'=>
            [
                'required'
            ],
        ];

        if (request('email') && request('code_1') && request('code_2') && request('code_3') && request('code_4'))
        {
            $code = request('code_1').request('code_2').request('code_3').request('code_4');

            $code = $this->userService->checkCode([
                'email'=>request('email'),
                'code'=>$code,
            ]);
            if (!$code)
            {
                $rules['not_correct_code'] = 'required';
            }
        }

        return $rules;
    }

    public function messages()
    {
        return [
            'not_correct_code.required' => __('web.not_correct_code')
        ];
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'email'=>__('web.email'),
            'code_1'=>__('web.code'),
            'code_2'=>__('web.code'),
            'code_3'=>__('web.code'),
            'code_4'=>__('web.code'),
        ];

        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            parent::failedValidation($validator);
        }
    }
}
